<template>
  <div
    v-loading="isLoading"
    class="landing-page min-h-ful h-full m-0 pt-4 text-sm font-light overflow-x-hidden"
  >
    <article class="overflow-hidden ml-auto">
      <header>
        <div class="landing-container mx-auto w-full">
          <div class="text-center mx-auto mb-2 w-[58%] logo">
            <img :src="getAssetImage('assets/theme/landing/logo.png')" />
          </div>
          <div class="text-center slogan mb-[0.7rem] w-full">
            <img :src="getAssetImage('assets/theme/landing/slogan.png')" />
          </div>
        </div>
      </header>
      <div class="landing-container mx-auto w-full">
        <div class="tab-content">
          <div id="register">
            <div class="text-center lbl-form pb-4">
              <span>Tham gia cùng </span>
              <span class="spanstyle1">Z.b.e.t</span>
              <br />
              <span>để nhận được vô vàn những ưu đãi hấp dẫn</span>
            </div>
          </div>
          <el-form
            ref="formRef"
            label-position="left"
            :rules="landingPageFormRule"
            :model="formModel"
            :validate-on-rule-change="false"
          >
            <el-form-item
              :class="{ required: landingPageFormRule.Username.required }"
              prop="Username"
            >
              <el-input v-model="formModel.Username" placeholder="Tên đăng nhập" />
            </el-form-item>
            <el-form-item prop="Phone">
              <el-input
                id="registerPhoneNumber"
                v-model="formModel.Phone"
                placeholder="Số điện thoại"
                :formatter="(value: string) => value"
                :parser="(value: string) => value.replace(/\D+/g, '')"
              ></el-input>
            </el-form-item>
            <el-form-item
              :class="{ required: landingPageFormRule.Password.required }"
              prop="Password"
            >
              <el-input
                v-model="formModel.Password"
                :type="isShowPassword ? 'text' : 'password'"
                placeholder="Mật khẩu"
              >
                <template #suffix>
                  <div class="flex items-center justify-center">
                    <a href="#" class="h-min" @click.prevent="onToggleIsShowPassword">
                      <IEye v-if="!isShowPassword" class="h-5 text-[#868a92]" />
                      <IEyeSlash v-else class="h-5 text-[#868a92]" />
                    </a>
                  </div>
                </template>
              </el-input>
            </el-form-item>
            <div>
              <button
                class="btnsubmit"
                type="button"
                @click.prevent="onRegisterFromLanding(formRef)"
              >
                <img :src="getAssetImage('assets/theme/landing/btn-dangky.png')" />
              </button>
            </div>
          </el-form>
        </div>
      </div>
    </article>
  </div>
</template>

<script setup lang="ts">
import useRegister from "@/composables/useRegister";
import IEye from "~/assets/icons/eye.svg?component";
import IEyeSlash from "~/assets/icons/eye-slash.svg?component";

const { getAssetImage } = commonHelper;

const bgLeftUrl = "assets/theme/landing/bg-left.png";
const bgUrl = "assets/theme/landing/bg.jpeg";
const bgFormUrl = "assets/theme/landing/bg-form.png";
const bgMobileUrl = "assets/theme/landing/bg-mobile.jpeg";
const bgMobile = `url(${getAssetImage(bgMobileUrl)})`;
const bgLeft = `url(${getAssetImage(bgLeftUrl)})`;
const bg = `url(${getAssetImage(bgUrl)})`;
const bgForm = `url(${getAssetImage(bgFormUrl)})`;

const {
  formModel,
  formRef,
  onRegisterFromLanding,
  landingPageFormRule,
  isLoading,
  onToggleIsShowPassword,
  isShowPassword,
} = useRegister();
</script>

<style lang="scss">
.landing-page {
  font-family: Montserrat, sans-serif;
  color: #dab777;
  z-index: -1;
  background: v-bind("bgLeft") 50% calc(100% + 6rem) no-repeat, v-bind("bgMobile") bottom center no-repeat fixed;
  background-size: 60% auto, cover;
  background-color: #012199;
  padding-top: .5rem;
  height: 100vh;

  .el-form-item.is-error .el-input__inner {
    box-shadow: none;
  }

  .el-loading-mask {
    --el-color-primary: var(--primary);

    background-color: rgba(47, 43, 38, 0.5);
    width: 100%;
    height: 100%;
    position: fixed;
  }

  article {
    width: 100%;
  }

  .landing-container {
    max-width: 550px;
    padding: 0 10px;
  }

  .tab-content {
    width: 100%;
    padding: 2rem 0;
    padding-top: 0.5rem;
    margin: 0 auto;
    position: relative;
    background: v-bind("bgForm") top center no-repeat;
    background-size: 100% 100%;
  }

  .lbl-form {
    line-height: 1.3;
    color: #fff;
    font-size: 12px;
    padding-bottom: 1rem;
  }

  .lbl-form span {
    text-decoration-line: line-through;
    text-decoration-color: #0f192f;
  }

  .lbl-form .spanstyle1 {
    font-weight: 700;
    font-size: 20px;
    color: #009c3b;
    line-height: 1;
  }

  .el-form {
    width: 90%;
    margin: 0 auto;

    .el-form-item {
      margin-bottom: 0;
      min-height: 52px;
      align-items: start;
    }

    .el-form-item__error {
      color: red;
      font-size: 14px;
      text-align: center;
      width: 100%;
      padding: 4px 0;
    }
  }

  .el-input__inner {
    height: 34px;
    box-shadow: none;
    background: #283145 !important;
    margin: 0 auto;
    padding: 0 40px 0 20px;
    color: #fff !important;
    border-radius: 3px;
    font-size: 14px;
    border: none !important;
    font-weight: 300;
  }

  .btnsubmit {
    width: 100%;
    background: 0 0;
    border: none;
    outline: 0;
    margin: 0 auto;
    display: block;
    animation: btnAnimation 0.6s linear infinite;
    height: auto;
    padding: 0;
  }

  @media (min-width: 320px) {
    .el-input__inner {
      height: 36px;
    }
  }

  @media (min-width: 360px) {
    .lbl-form {
      font-size: 14px;
    }

    .el-input__inner {
      height: 40px;
    }
  }

  @media (min-width: 480px) {
    background: v-bind("bgLeft") 50% calc(100% + 4rem) no-repeat, v-bind("bgMobile") bottom center no-repeat fixed;
    background-size: 50% auto, cover;
    background-color: #012199;
    padding-top: .5rem;

    .el-form .el-form-item {
      min-height: 77px;
    }

    .landing-container {
      padding: 0 15px;
    }

    .tab-content {
      width: 88%;
      padding: 2rem 0;
    }

    .el-input__inner {
      height: 55px;
      padding: 0 55px 0 20px;
    }
  }

  @media (min-width: 640px) {
    background: v-bind("bgLeft") 50% calc(100% + 5rem) no-repeat, v-bind("bgMobile") bottom center no-repeat fixed;
    background-size: 40% auto, cover;
    background-color: #012199;
    padding-top: .5rem;

    .lbl-form {
      font-size: 20px;

      .spanstyle1 {
        font-size: 30px;
      }
    }
  }

  @media (min-width: 768px) {
    background: v-bind("bgLeft") bottom center no-repeat, v-bind("bgMobile") bottom center no-repeat fixed;
    background-size: 40% auto, cover;
    background-color: #012199;
  }

  @media (min-width: 991px) {
    background: v-bind("bgLeft") -5rem 100% no-repeat, v-bind("bg") top center no-repeat fixed;
    background-size: auto 80%, 100% 100%;
    background-color: #012199;
    padding-top: 0;
    padding: 1rem 0 0;

    article {
      width: 70%;
    }
  }

  @media (min-width: 1025px) {
    background: v-bind("bgLeft") bottom left no-repeat, v-bind("bg") top center no-repeat fixed;
    background-size: auto 90%, 100% 100%;
    background-color: #012199;
    padding: 1rem 0 0;

    .landing-container {
      max-width: 640px;
    }
  }

  @media (min-width: 1300px) {
    background: v-bind("bgLeft") bottom left no-repeat, v-bind("bg") top center no-repeat fixed;
    background-size: auto 98%, cover;
    background-color: #012199;
    padding: 1rem 0 0;

    .landing-container {
      max-width: 750px;
    }
  }

  @keyframes btnAnimation {
    0% {
      transform: scale(1.04);
      -webkit-filter: drop-shadow(2px 2px 10px #fef57b) brightness(1.6);
      filter: drop-shadow(2px 2px 10px #fef57b) brightness(1.6);
    }

    50% {
      transform: scale(1);
      -webkit-filter: brightness(1);
      filter: brightness(1);
    }

    100% {
      transform: scale(1.04);
      -webkit-filter: drop-shadow(2px 2px 10px #fef57b) brightness(1.6);
      filter: drop-shadow(2px 2px 10px #fef57b) brightness(1.6);
    }
  }
}
</style>
<style scoped>
  :deep(.el-overlay) {
    width: 100%;
  }
</style>
